Unit Spoj;

interface

Uses SysUtils, Dialogs, Bsc;

Procedure Spoj_Compile(txtfile,datfile,namefile:String);

implementation

type rect=packed record
              s:byte;
              a1:Word; d1:SmallInt;   { RA, DE 2000 }
              x1,y1,z1:SmallInt; { x, y, z }
              a2:Word; d2:SmallInt;   { RA, DE 2000 }
              x2,y2,z2:SmallInt; { x, y, z }
          end;
type
      TStarRec = record G,S,N:String; a:word; d,x,y,z:SmallInt; end;
var
      dbf:array[0..10000] of TStarRec;
      k:integer;

function value(s:string):longint;
var a:longint; c:integer;
begin
val(s,a,c);
value:=a;
end;

function valb(svalue : string):byte;
var a:SmallInt; b:integer;
    s:string;
begin
s:=svalue;
if svalue[1]=' ' then svalue:=copy(svalue,2,length(svalue)-1);
if svalue[length(svalue)]=' ' then svalue:=copy(svalue,1,pos(' ',svalue)-1);
val(svalue,a,b); a:=round(a/10); if a<0 then a:=128-a; valb:=a;
end;

Function NextRec(var r:text; var rec:TStarRec):boolean;
var dbfs:string[255];
    alfa,delta:real;
begin
if eof(r) then Result:=false else begin Result:=true;
  Readln(r,dbfs);
  alfa:=value(copy(dbfs,1,5))/1500;
  delta:=value(copy(dbfs,6,5))/100;
  with rec do begin
  a:=round(alfa/24*65536);
  d:=round(delta/90*32767);
  x:=round(cos(delta*pi/180)*cos((24-alfa)*pi/12)*32767);
  y:=round(cos(delta*pi/180)*sin((24-alfa)*pi/12)*32767);
  z:=round(sin(delta*pi/180)*32767);
  n:=trim(copy(dbfs,11,3));
  g:=trim(copy(dbfs,14,3));
  s:=trim(copy(dbfs,18,3));
  end;
end;
end;

Function bsc_s(g,c:String; var rec:TStarRec):boolean;
var i:integer;
begin
 Result:=false;
 for i:=0 to k-1 do
   if (dbf[i].s=trim(c)) and ((dbf[i].g=trim(g)) or (dbf[i].n=trim(g))) then begin
     rec:=dbf[i];
     Result:=true; exit;
   end;
end; 

Procedure Spoj_Compile(txtfile,datfile,namefile:String);
var sou:String; rec:rect; rc,rc2:TStarRec; s:String;
var r:text; w:file of rect; b:text; Errors:String;
begin
sou:=''; Errors:='';
assign(b,namefile); reset(b); k:=0;
while nextrec(b,dbf[k]) do k:=k+1;
close(b); 
assign(r,txtfile); assign(w,datfile); reset(r); rewrite(w);
repeat
  readln(r,s);
  if s[4]=':' then begin
    sou:=copy(s,1,3);
  end else begin
    if not bsc_s(copy(s,1,3),sou,rc) then
      Errors:=Errors+sou+': '+copy(s,1,3)+'; '
    else if not bsc_s(copy(s,5,3),sou,rc2) then
      Errors:=Errors+sou+': '+copy(s,5,3)+'; '
    else begin
      rec.s:=C_To_Byte(rc.s);
      rec.a1:=rc.a; rec.d1:=rc.d;
      rec.x1:=rc.x; rec.y1:=rc.y; rec.z1:=rc.z;
      rec.a2:=rc2.a; rec.d2:=rc2.d;
      rec.x2:=rc2.x; rec.y2:=rc2.y; rec.z2:=rc2.z;
      write(w,rec);
    end;
  end;
until uppercase(s)='END:';
if Length(Errors)>0 then ShowMessage(Errors)
                    else ShowMessage('OK');  
close(r); close(w);
end;

end.


